<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\DealerVisitPlan;
use App\Models\User;

class DealerVisitPlanPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any DealerVisitPlan');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, DealerVisitPlan $dealervisitplan): bool
    {
        return $user->checkPermissionTo('view DealerVisitPlan');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create DealerVisitPlan');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, DealerVisitPlan $dealervisitplan): bool
    {
        return $user->checkPermissionTo('update DealerVisitPlan');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, DealerVisitPlan $dealervisitplan): bool
    {
        return $user->checkPermissionTo('delete DealerVisitPlan');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any DealerVisitPlan');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, DealerVisitPlan $dealervisitplan): bool
    {
        return $user->checkPermissionTo('restore DealerVisitPlan');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any DealerVisitPlan');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, DealerVisitPlan $dealervisitplan): bool
    {
        return $user->checkPermissionTo('replicate DealerVisitPlan');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder DealerVisitPlan');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, DealerVisitPlan $dealervisitplan): bool
    {
        return $user->checkPermissionTo('force-delete DealerVisitPlan');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any DealerVisitPlan');
    }
}
